<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="规则名称" prop="ruleName">
        <el-input
          v-model="queryParams.ruleName"
          placeholder="请输入规则名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="策略名称" prop="strategyId">
        <el-input
          v-model="queryParams.strategyId"
          placeholder="请输入策略id"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="滑窗时间" prop="slideTime">
        <el-input
          v-model="queryParams.slideTime"
          placeholder="请输入滑窗时间"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="滑窗频率" prop="slideFrequency">
        <el-input
          v-model="queryParams.slideFrequency"
          placeholder="请输入滑窗频率"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['platform:rule:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['platform:rule:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['platform:rule:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['platform:rule:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="ruleList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="规则id" align="center" prop="id" />
      <el-table-column label="规则名称" align="center" prop="ruleName" />
      <el-table-column label="策略id" align="center" prop="strategyId" />
      <el-table-column label="报文数据类型id" align="center" prop="msgTypeId" />
      <el-table-column label="滑窗时间" align="center" prop="slideTime" />
      <el-table-column label="滑窗频率" align="center" prop="slideFrequency" />
      <el-table-column label="数据频率名称" align="center" prop="slideData" />
      <el-table-column label="数据频率最大值" align="center" prop="slideMaxNum" />
      <el-table-column label="数据频率最小值" align="center" prop="slideMinNum" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['platform:rule:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['platform:rule:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改预警规则对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="策略名称" prop="strategyId">
          <el-select v-model="form.strategyId" placeholder="请选择策略模版id" @change="getFindByTemplateValue">
            <el-option
              v-for="item in strategyList"
              :key="item.id"
              :label="item.strategyName"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="规则名称" prop="ruleName">
          <el-input v-model="form.ruleName" placeholder="请输入规则名称" />
        </el-form-item>
        <el-form-item label="报文数据类型id" prop="msgTypeId">
          <el-select ref="select" v-model="form.msgTypeId" multiple placeholder="请选择报文数据名称">
            <el-option
              v-for="item in templateValueList"
              :key="item.messageId"
              :label="item.messageCode"
              :value="item.messageId">
<!--              <el-checkbox @change="clickBox(item.messageId)" :value ="value.includes(item.messageId)" :label="item.messageCode"></el-checkbox>-->
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="滑窗时间" prop="slideTime">
          <el-slider v-model="form.slideTime" :min="1" :max="1000"></el-slider>
          <el-input-number v-model="form.slideTime" :min="1" :max="1000"></el-input-number>
        </el-form-item>
        <el-form-item label="滑窗频率" prop="slideFrequency">
          <el-select  v-model="form.slideFrequency" placeholder="请选择滑窗频率">
            <el-option  value="1:2">1:2</el-option>
            <el-option  value="1:5">1:5</el-option>
            <el-option  value="1:10">1:10</el-option>
            <el-option  value="1:20">1:20</el-option>
            <el-option  value="1:30">1:30</el-option>
            <el-option  value="1:60">1:60</el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="数据频率名称" prop="slideData">
          <el-input v-model="form.slideData" placeholder="请输入数据频率名称" />

        </el-form-item>
        <el-form-item label="数据频率最大值" prop="slideMaxNum">
          <el-input v-model="form.slideMaxNum" placeholder="请输入数据频率最大值" />
        </el-form-item>
        <el-form-item label="数据频率最小值" prop="slideMinNum">
          <el-input v-model="form.slideMinNum" placeholder="请输入数据频率最小值" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRule, getRule, delRule, addRule, updateRule } from "/src/api/platform/rule";
import { listStrategy} from "@/api/platform/strategy";
import {valueList} from "@/api/car/message/template";

export default {
  name: "Rule",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      props: { multiple: true },
      // 显示搜索条件
      showSearch: true,

      // 总条数
      total: 0,
      // 预警规则表格数据
      ruleList: [],
      //车辆类型
      sysTypeList :[],
      //报文字段
      templateValueList:[],
      value:[],
      //报文模版类型
      templateList :[],

      //报文类型Id
      templateId : null,
      //车辆类型Id
      sysTypeId: null,
      //策略信息组
      strategyList : [],
      //策略信息
      strategy: {},
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      //弹出抽屉
      drawer:false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        ruleName: null,
        strategyId: null,
        msgTypeId: null,
        slideTime: null,
        slideFrequency: null,
        slideData:null,
        slideMaxNum: null,
        slideMinNum: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    clickBox(val) {
      console.log('val::', val);
      let values = this.value
      if(values.includes(val)) {
        this.value = values.filter(n => n !== val)
      } else {
        values.push(val)
        this.value = values
      }
      console.log('this.value::', this.value)

    },
    /** 查询预警规则列表 */
    getList() {
      this.loading = true;
      listRule(this.queryParams).then(response => {
        this.ruleList = response.data.rows;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        ruleName: null,
        strategyId: null,
        msgTypeId: null,
        slideTime: null,
        slideFrequency: null,
        slideData:null,
        slideMaxNum: null,
        slideMinNum: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加预警规则";
      this.findInformation();
    },
    findInformation(){
      /** 策略信息 **/
      listStrategy().then(res=>{
        this.strategyList  = res.data.rows;
      })
    },

    getFindByTemplateValue(val){
      const { msgId } = this.strategyList.find(strategy => strategy.id === val)
      valueList({messageTemplateId:msgId}).then(res=>{
        this.templateValueList = res.data
      })
    },

    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getRule(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改预警规则";
      });
      this.findInformation();
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateRule(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRule(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除预警规则编号为"' + ids + '"的数据项？').then(function() {
        return delRule(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('platform/rule/export', {
        ...this.queryParams
      }, `rule_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
